<template lang="pug">
q-card(flat, bordered)
  q-card-section.col(horizontal, v-if="!isRequesting")
    q-card-section.col
      BasicCallDetails(
        :call="calls[0]",
        :countOfOthersInGroup="calls.length - 1"
      )
    q-separator(vertical)
    q-card-actions.justify-center.q-px-md(vertical)
      q-btn(
        round,
        size="1.4em",
        color="positive",
        outline,
        icon="add",
        @click="isRequesting = true"
      )
        q-tooltip Schedule ZoomSense for this class

  q-card-section.bg-blue-2.q-pa-sm.row.items-center(
    v-if="calls.length > 1",
    horizontal
  )
    .col This looks like a recurring meeting
    q-btn(flat, dense, @click="$emit('requestStopGrouping')") Schedule Individually

  q-card-section.text-white.text-center.full-height.full-width.bg-positive(
    v-if="isRequesting",
    horizontal
  )
    q-card-section.col(horizontal)
      q-btn.self-start.q-ma-sm(
        icon="close",
        flat,
        color="white",
        round,
        @click="isRequesting = false"
      )
      q-card-section.col
        .col-auto.text-h5.justify-center(v-if="calls[0].type !== 'webinar'")
          .col-auto.q-mb-xs Request ZoomSense with
          .col-auto
            q-input.text-h6(
              dark,
              rounded,
              outlined,
              type="number",
              name="breakoutrooms",
              min="1",
              max="10",
              v-model="noOfBreakoutRooms",
              :dense="true",
              style="width: 5em; display: inline-block"
            )
          .col-auto
            div Sensors (Breakout Rooms)
        .column.justify-center.self-center.full-height(v-else)
          .col-auto
            .text-h5 Request ZoomSense for Your Webinar

      q-card-actions.justify-center.q-px-md(vertical)
        q-btn(
          :disable="requestLoading",
          round,
          size="1.4em",
          color="white",
          outline,
          icon="check",
          @click="requestZoomSense"
        )
          q-tooltip Schedule ZoomSense for this class
  q-inner-loading.text-white.bg-green(:showing="requestLoading", dark)
    q-spinner-dots(color="white", size="xl")
    div {{ currentScheduled }} of {{ countOfCallsToSchedule }} scheduled
</template>
<script>
import { config, functions } from "../db";
import BasicCallDetails from "./BasicCallDetails.vue";

// Given a list of calls, allow the users to request ZoomSense meetings for them
export default {
  props: {
    calls: { required: true },
  },
  data() {
    return {
      isRequesting: false,
      requestLoading: false,
      noOfBreakoutRooms: 2,
      currentScheduled: 0,
      countOfCallsToSchedule: undefined,
    };
  },
  methods: {
    async requestZoomSense() {
      if (this.requestLoading) return;
      this.requestLoading = true;
      this.countOfCallsToSchedule = this.calls.length;
      for (let call of this.calls) {
        call.noOfBreakoutRooms =
          call.type === "webinar" ? 1 : parseInt(this.noOfBreakoutRooms);

        try {
          const createMeeting = functions.httpsCallable(
            "createZoomSenseMeeting",
          );
          const duration =
            (new Date(call.endTime).valueOf() -
              new Date(call.startTime).valueOf()) /
            1000 /
            60;
          const capacity = (
            await this.$http.post(
              `${config.functions_url}/getMeetingCapacityManual`,
              {
                duration,
                start_time: call.startTime,
              },
            )
          ).data.capacity;

          if (call.noOfBreakoutRooms > capacity) {
            this.$q.notify({
              type: "negative",
              message: `No. of Breakout Rooms cannot exceed ${capacity} for this meeting.`,
              actions: [
                {
                  label: "Autofill",
                  color: "yellow",
                  handler: () => {
                    this.noOfBreakoutRooms = capacity;
                  },
                },
              ],
            });
            this.requestLoading = false;
            return;
          }
          await createMeeting({
            meetingId: call.id,
            isWebinar: call.type === "webinar",
            startTime: call.startTime,
            duration,
            noOfBORooms: call.noOfBreakoutRooms,
            modules: {
              prompts: {
                enabled: true,
                // How often prompts are sent out, in minutes
                promptFrequency: 10,
                // How many minutes into the past the prompt creator looks back
                // when calculating who to send prompts to
                dataLookbackWindow: 5,
              },
            },
          });
        } catch (e) {
          this.$q.notify({
            type: "negative",
            message: e,
          });
          console.error(e);
        }
        this.currentScheduled++;
      }
      this.requestLoading = false;
      this.isRequesting = false;
    },
  },
  components: { BasicCallDetails },
};
</script>
